#include <stdio.h>

#define PRINT_FUNC(name, type, spec) \
  void print_##name (type x)         \
  {                                  \
    printf (spec "\n", x);           \
  }

PRINT_FUNC (int, int, "%d")
PRINT_FUNC (string, char *, "%s")

int main (void)
{
  print_string ("Hello, world!");
  print_int (42);
  return 0;
}
