#!/usr/bin/python2

from twisted.web.server import Site
from twisted.web.resource import Resource
from twisted.internet import reactor, endpoints

import cgi

class FormPage(Resource):
    def render_GET(self, request):
        return '<html><body><form action="/welcome" method="GET">Your name: ' \
               + '<input name="name" type="text" /><br/>' \
               + '<input type="submit"></form></body></html>'

class WelcomePage(Resource):
    def render_GET(self, request):
        return '<html><body>Hello, %s!<br/></body></html>' \
               % (cgi.escape(request.args["name"][0]),)

root = Resource()
root.putChild("form", FormPage())
root.putChild("welcome", WelcomePage())
factory = Site(root)
endpoint = endpoints.TCP4ServerEndpoint(reactor, 8880)
endpoint.listen(factory)
reactor.run()
